# Mitigating the Inconsistency Between Word Saliency and Model Confidence with Pathological Contrastive Training

Code for paper ''Mitigating the Inconsistency Between Word Saliency and Model Confidence with Pathological Contrastive Training''. Implementation of the Data augmentation module.



## Main idea

The data augmentation module will generate positive and negative samples in a self-supervised manner before the new mini-batch is sent to forward propagation. For each sample in the batch, we first use gradient-based attribution method to obtain the saliency of the normal input sentence. We then cumulatively reduce the important words in a descending order of saliency value to generate a text set containing texts with multiply important words are reduced. Parallelly, we generate the texts set by cumulatively reducing unimportant words.



## Data

The MR, AG News, and IMDB dataset used in our experiments is provided by the open-source library "dataset":

1. rotten_tomatoes
2. ag_news
2. imdb



##  Infrastructure

All experiments are conducted on one Nvidia V100 GPU.



## Requirements

The following packages should be installed:

```
textattack
transformers
sentence_transformers
torch
numpy
scipy
```